const semver = require('semver')

const utils = {}

utils.generateVersions = () => [ // all three-digit version numbers
  "1.0.0",
  "1.0.1",
  "1.0.2",
  "1.0.3",
  "1.0.4",
  "1.1.0",
  "1.1.1",
  "1.1.2",
  "1.1.3",
  "1.1.4",
  "1.2.0",
  "1.2.1",
  "1.2.2",
  "1.2.3",
  "1.2.4",
  "1.2.5",
  "1.2.6",
  "1.3.0",
  "1.3.0",
  "1.3.1",
  "1.3.2",
  "1.4.0",
  "1.4.0",
  "1.4.1",
  "1.4.2",
  "1.4.3",
  "1.4.4",
  "1.5.0",
  "1.5.0",
  "1.5.1",
  "1.5.2",
  "1.6.0",
  "1.6.0",
  "1.6.1",
  "1.6.2",
  "1.6.3",
  "1.6.4",
  "1.7.0",
  "1.7.0",
  "1.7.1",
  "1.7.2",
  "1.8.0",
  "1.8.1",
  "1.8.2",
  "1.8.3",
  "1.9.0",
  "1.9.1",
  "1.10.0",
  "1.10.1",
  "1.10.2",
  "1.11.0",
  "1.11.1",
  "1.11.2",
  "1.11.3",
  "1.12.0",
  "1.12.1",
  "1.12.2",
  "1.12.3",
  "1.12.4",
  "2.0.0",
  "2.0.1",
  "2.0.2",
  "2.0.3",
  "2.1.0",
  "2.1.1",
  "2.1.2",
  "2.1.3",
  "2.1.4",
  "2.2.0",
  "2.2.1",
  "2.2.2",
  "2.2.3",
  "2.2.4",
  "3.0.0",
  "3.1.0",
  "3.1.1",
  "3.2.0",
  "3.2.1",
  "3.3.0",
  "3.3.1",
  "3.4.0",
  "3.4.1",
]

utils.resolveTags = (versions => ({ tags, fixFrom }) =>
    (tags || [])
      .sort()
      .concat(
        versions
          .filter(version => semver.satisfies(version, `>=${fixFrom}`))
          .map(version => `fixable-from-v${version}`)
      )
)(utils.generateVersions())

module.exports = utils;